# Moosend: Email Marketing Software for Thriving Businesses

Drupal Module for Moosend EMS using
their [API v3](https://docs.moosend.com/developers/api-documentation/en/index-en.html).
Maintained and supported by
[Sujan Shrestha](https://www.drupal.org/u/sujan-shrestha).

## INTRODUCTION

This module uses
[v3](https://docs.moosend.com/developers/api-documentation/en/index-en.html) of
the Moosend EMS API.
It allows users to add an API key and secret generated by a Moosend account in the settings.php file (or via an admin UI). Then will allow users to activate/enable a list and create a block derivative for each list that is enabled. It also provides an optional REST endpoint to send signups to the CC API for enabled lists.

For a full description of the module, visit the [project page](https://www.drupal.org/project/moosend_ems).

To submit bug reports and feature suggestions, or track changes visit the [project issue page](https://www.drupal.org/project/issues/moosend_ems).

## REQUIREMENTS

This module requires the following modules enabled in Drupal Core:

* Block
* REST (if wanting to use the provided REST endpoint)
* Datetime (if using custom date fields)
* Webform (if wanting to send webform submissions to a enabled list)

This module also requires a [Moosend](https://www.moosend.com) account
as well as an app created on the [developer portal](https://docs.moosend.com/developers/api-documentation/en/index-en.html).

## INSTALLATION

* Install as you would normally install a contributed Drupal module.
[Visit Drupal's documentation for further information](https://www.drupal.org/documentation/install/modules-themes/modules-7).

## CONFIGURATION

* Configure the user permissions in Administration » People » Permissions
* Create an app on Moosend EMS's
[developer portal](https://docs.moosend.com/developers/api-documentation/en/index-en.html).
* Copy the API Key provided, add the key to your settings.php file.
* Your settings.php entry should look like this:

```php
$settings['moosend_ems'] = [
  'api_key' => 'your_api_key',
];
```

* If you prefer to use the UI, you can add these values to the admin UI form located at `admin/config/services/moosend-ems`. Click save.
* Click the Authorize button to authorize your account (you may need to log into Constsant Contact again) to generate tokens.
* Once tokens are generated, go to `admin/config/services/moosend-ems/lists` to enable the lists you'd like to place as blocks on your site or use as a REST endpoint.

## WEBFORM HANDLER CONFIGURATION

* Go to Webforms list page (admin/structure/webform) and click "Edit" on the desired Webform.
* Click Emails/Handlers secondary tab and then click on "Add handler" button.
* Click on "Add handler" button on "Moosend EMS" row.
* Fill in the form. You should have at least one list in your Moosend EMS account, at least one list enabled in your Moosend EMS Module settings (/admin/config/services/moosend-ems/lists), and at least one Email field in your Webform.

